"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
function calculateStuff(containerHeight, scrollTop, virtualization, dataLength) {
    var top = scrollTop;
    var renderAround = virtualization.renderAround ? virtualization.renderAround : 5;
    var firstIndexOnScreen = Math.max(Math.floor(top / virtualization.rowHeight) - renderAround, 0);
    var lastIndexOnScreen = Math.min(Math.ceil(containerHeight / virtualization.rowHeight) + firstIndexOnScreen + renderAround * 2, dataLength);
    var firstBlockHeight = firstIndexOnScreen * virtualization.rowHeight;
    var lastBlockHeight = (dataLength - lastIndexOnScreen) * virtualization.rowHeight;
    return { firstBlockHeight: firstBlockHeight, lastBlockHeight: lastBlockHeight, firstIndexOnScreen: firstIndexOnScreen, lastIndexOnScreen: lastIndexOnScreen };
}
var VirtualContainer = /** @class */ (function (_super) {
    __extends(VirtualContainer, _super);
    function VirtualContainer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            containerHeight: window.innerHeight,
            scrollTop: 0
        };
        _this.onScroll = function () {
            if (window.scrollY > document.body.scrollHeight - window.innerHeight) {
                if (_this.props.onScrolledToBottom)
                    _this.props.onScrolledToBottom();
            }
            else if (window.scrollY <= 0) {
                if (_this.props.onScrolledToTop)
                    _this.props.onScrolledToTop();
            }
            _this.setState({ scrollTop: window.scrollY });
        };
        return _this;
    }
    VirtualContainer.prototype.render = function () {
        var _this = this;
        var _a = calculateStuff(this.state.containerHeight, this.state.scrollTop, this.props.virtualization, this.props.value.length), firstBlockHeight = _a.firstBlockHeight, lastBlockHeight = _a.lastBlockHeight, firstIndexOnScreen = _a.firstIndexOnScreen, lastIndexOnScreen = _a.lastIndexOnScreen;
        if (this.props._type === 'tbody') {
            return (React.createElement("tbody", null,
                React.createElement("tr", { style: { height: firstBlockHeight } }),
                this.props.value.slice(firstIndexOnScreen, lastIndexOnScreen).map(function (value) {
                    var key = value[_this.props.childKey].toString();
                    return React.createElement(React.Fragment, { key: key }, _this.props.children(value));
                }),
                React.createElement("tr", { style: { height: lastBlockHeight } })));
        }
        else {
            return (React.createElement("div", { style: { paddingTop: firstBlockHeight, paddingBottom: lastBlockHeight } }, this.props.value.slice(firstIndexOnScreen, lastIndexOnScreen).map(function (value) {
                var key = value[_this.props.childKey].toString();
                return React.createElement(React.Fragment, { key: key }, _this.props.children(value));
            })));
        }
    };
    VirtualContainer.prototype.componentWillUnmount = function () {
        window.removeEventListener('scroll', this.onScroll);
    };
    VirtualContainer.prototype.componentDidMount = function () {
        this.setState({
            containerHeight: window.innerHeight,
            scrollTop: 0
        });
        window.addEventListener('scroll', this.onScroll);
    };
    return VirtualContainer;
}(React.Component));
function List(props) {
    return React.createElement(VirtualContainer, __assign({}, props, { _type: "div" }));
}
exports.List = List;
function TBody(props) {
    return React.createElement(VirtualContainer, __assign({}, props, { _type: "tbody" }));
}
exports.TBody = TBody;
//# sourceMappingURL=VirtualContainer.js.map