/// <reference types="react" />
declare type VirtualizationPropType = {
    rowHeight: number;
    renderAround?: number;
};
export interface VirtualContainerProps<T> {
    value: T[];
    virtualization: VirtualizationPropType;
    onScrolledToBottom?: () => void;
    onScrolledToTop?: () => void;
    childKey: keyof T;
    children: (data: T) => JSX.Element;
}
export interface VirtualContainerState {
    scrollTop: number;
    containerHeight: number;
}
export declare function List<T>(props: VirtualContainerProps<T>): JSX.Element;
export declare function TBody<T>(props: VirtualContainerProps<T>): JSX.Element;
export {};
